package gest_bacino;

import java.util.*;
import java.net.*;
import java.io.*;
import java.lang.*;
public class GestSecond implements Runnable {
	private Thread present;
	byte outBuffer[];
	byte inBuffer[] = new byte[Manager.bufferLength];
	
public GestSecond() {
	present = new Thread(this);
	present.start();
}
/**
 * Spezzetta una stringa di almeno(!) quattro linee
 * in un array di quattro stringhe
 * Il separatore  \n
 */
public String[] parsering(String ingresso) throws IOException {
	String stringa = "";
	int indice = 0;
	String temp[] = new String[4];
	BufferedReader inStream = new BufferedReader(new StringReader(ingresso));
	while (indice <= 3) {
		stringa = inStream.readLine();
		temp[indice] = stringa;
		indice++;
	}
	return temp;
}
public void run() {
	Synchro gamma = new Synchro();
	try {
		int x;
		String bluff[];
		bluff = new String[4];
		DatagramSocket socket = new DatagramSocket(110);
		int localPort = socket.getLocalPort();
		DatagramPacket outDatagram;
		DatagramPacket inDatagram = new DatagramPacket(inBuffer, inBuffer.length);
		System.out.println("\nManagerSecondario in ascolto sulla porta " + localPort + ".\n");
		while (!Manager.chiusura_sec) {
			socket.receive(inDatagram);
			/** ATTESA...*/

			InetAddress sensAddr = inDatagram.getAddress();
			int sensPort = inDatagram.getPort();
			String data = new String((inDatagram.getData())).trim();
			bluff = parsering(data);
			switch (x = scelta(bluff[1])) {case 1 :
				/* presentazione */
				{outBuffer = "LASCIAMI STARE".getBytes();
				outDatagram = new DatagramPacket(outBuffer, outBuffer.length, sensAddr, sensPort);
				socket.send(outDatagram);
				/* SPEDIZIONE RISPOSTA  */
		}
		break;
	case 2 :
		/* aggiornamento */
		{
			int h = gamma.libero();
			if (h != -1) {
				gamma.aggiorn(h, bluff);
				System.out.println("E' entrato il sensore " + h + " di nome <" + bluff[0] + ">");
			} else
				System.out.println("Troppi sensori! Il numero" + h + " di nome <" + bluff[0] + "> non pu entrare");
		}
		break;
	case 3 :
		/* aggiorna IP e porta del sensore */
		{
			int i = gamma.posizione(bluff[0]);
			if (i != -1) {
				gamma.aggIP(i, bluff);
				System.out.println("IP e porta OK\n");
			} else
				System.out.println("Nessun sensore di nome <" + bluff[0] + ">.");
		}
		break;
	case 4 :
		/* appena entrato il secondario viene informato sui sensori gi connessi: nome, IP, porta */
		{
			int j = gamma.libero();
			if (j != -1) {
				gamma.aggIP(j, bluff);
				System.out.println("Il sensore " + j + " di nome <" + bluff[0] + "> era prec connesso al primario\n");
			} else
				System.out.println("Troppi sensori! Il numero" + j + " di nome <" + bluff[0] + "> non pu entrare");
		}
		break;
	case 5 :
		;
		/* si esce da while e cos si termina */
		break;
	case 6 :
		/* esce un sensore */
		{
			int g = gamma.posizione(bluff[0]);
			if (g != -1) {
				gamma.esce(g);
				System.out.println("\nEsce il sensore " + g + ": <" + bluff[0] + ">");
			} else
				System.out.println("Nessun sensore di nome <" + bluff[0] + ">.");
		}
		break;
	default :
		System.out.println("\nDati OSCURI\n");
	}
	/*switch*/
}
/* while */
socket.close();
} catch (IOException e) {
	System.out.println("\nSOS IOException nel Theread GESTSECOND");
}
}
/**
 * default = 0
 */
public int scelta(String msg) {
	int h = 0;
	if (msg.equals("PRESENTAZIONE"))
		h = 1;
	if (msg.equals("AGGIORNAMENTO"))
		h = 2;
	if (msg.equals("AGG_IIP_PORTA"))
		h = 3;
	if (msg.equals("SENSORICONNES"))
		h = 4;
	if (msg.equals("SICHIUDETUTTO"))
		h = 5;
	if (msg.equals("ESCEUNSENSORE"))
		h = 6;
	return h;
}
}
