package gest_bacino;

import java.net.*;
import java.io.*;
import java.lang.*;
import java.util.*;
public class GestSensori implements Runnable {
	private Thread present;
	byte outBuffer[];
	byte inBuffer[] = new byte[Manager.bufferLength];
public GestSensori() {
	present = new Thread(this);
	present.start();
}
/**
 * Spezzetta una stringa di almeno(!) quattro linee
 * in un array di quattro stringhe
 * Il separatore  \n
 */
public String[] parsering(String ingresso) throws IOException {
	String stringa = "";
	int indice = 0;
	String temp[] = new String[4];
	BufferedReader inStream = new BufferedReader(new StringReader(ingresso));
	while (indice <= 3) {
		stringa = inStream.readLine();
		temp[indice] = stringa;
		indice++;
	}
	return temp;
}
public void run() {
	int x;
	Synchro alfa = new Synchro();
	InetAddress indirizzo;
	String bluff[];
	bluff = new String[4];
	File ff = new File(Manager.fileanomalie);
	try {
		OutputStream fg = new FileOutputStream(ff);
		fg.write("INIZIO".getBytes());
		indirizzo = InetAddress.getByName(Manager.altro_manager);
		DatagramSocket socket = new DatagramSocket(100);
		String localAddress = InetAddress.getLocalHost().getHostName().trim();
		int localPort = socket.getLocalPort();
		DatagramPacket outDatagram;
		DatagramPacket inDatagram = new DatagramPacket(inBuffer, inBuffer.length);
		System.out.println("\nManagerPrimario in ascolto sulla porta " + localPort + ".\n");
		while (!Manager.chiusura_prim) {
			socket.receive(inDatagram);
			/** ATTESA...*/
			InetAddress sensAddr = inDatagram.getAddress();
			int sensPort = inDatagram.getPort();
			String data = new String((inDatagram.getData())).trim();
			/* modello la risposta a seconda se il sensore pu accedere e non
			 * so che altra condizione, poi lo faccio entrare! */
			bluff = parsering(data);
			switch (x = scelta(bluff[1])) {case 1 :
				/* PRESENTAZIONE
				controllo che un sensore con lo stesso NOME non sia gi registrato */
				int k = alfa.libero();
				{
					if (alfa.nome_unico(bluff[0]) && k != -1) {
						alfa.notif_reg(bluff, k);
						Date dt = new Date();
						String dtt = dt.toString();
						fg.write(("\n" + dtt + "\nENTRA\n" + bluff[0]).getBytes());
						if (!Manager.attendo_sec) {
							System.out.println("Spedisco al secondario i dati del sens entrato.");
							outBuffer = (Manager.nome_sens[k] + "\n" + "AGGIORNAMENTO\n" + Manager.grandezza[k] + "\n" + Manager.unita_mis[k] + "\n").getBytes();
							outDatagram = new DatagramPacket(outBuffer, outBuffer.length, indirizzo, 110);
							socket.send(outDatagram);
							/* SPEDIZIONE RISPOSTA */ }
						outBuffer = "OK".getBytes();
					} else
						outBuffer = "ESCI_SUBITO".getBytes();
				}
				break;
			case 3 :
				/* primovalore */ {
					int i = alfa.posizione(bluff[0]);
					if (i != -1) {
						System.out.println("Pervenuto il risultato della prima misurazione.");
						alfa.aggIP(i, bluff[0], sensAddr, sensPort);
						System.out.println("Registrati IP e porta del sensore appena entrato.");
						Date dt = new Date();
						String dtt = dt.toString();
						fg.write(("\n" + dtt + "\n" + bluff[0] + "\nPRIMOVALORE\n" + bluff[2]).getBytes());
						/* devo avvisare anche il sec dell'IP e della porta del sensore! */
						if (!Manager.attendo_sec) {
							outBuffer = (Manager.nome_sens[i] + "\nAGG_IIP_PORTA\n" + Manager.indirizIP[i].getHostName() + "\n" + (Manager.portasens[i] + "\n")).getBytes();
							outDatagram = new DatagramPacket(outBuffer, outBuffer.length, indirizzo, 110);
							socket.send(outDatagram);
							/* SPEDIZIONE RISPOSTA */
							System.out.println("Spediti IP e porta di tale sensore al secondario.");
						}
						outBuffer = "DATI_RICEV.".getBytes();
						System.out.println("Primo contatto col sensore OK.\n");
					} else {
						System.out.println("Nessun sensore di nome <" + bluff[0] + "> registrato.");
						outBuffer = "ESCI_SUBITO".getBytes();
					}
				}
				break;
			case 4 :
				/* alert */
				{
					int jk = alfa.posizione(bluff[0]);
					if (jk != -1) {
						System.out.println("ALERT: il sensore " + jk + " rileva grandezze anomale!!!");
						Date dt = new Date();
						String dtt = dt.toString();
						fg.write(("\n" + dtt + "\n" + bluff[0] + "\nALERT").getBytes());
						outBuffer = "DATI_RICEV.".getBytes();
						/* qui si prenderanno i provvedimenti del caso */
					} else {
						System.out.println("Nessun sensore di nome <" + bluff[0] + "> registrato.");
						outBuffer = "ESCI_SUBITO".getBytes();
					}
				}
				break;
			case 5 :
				/* il sensore ha accettato di scollegarsi */

				{
					int rr = alfa.posizione(bluff[0]);
					if (rr != -1) {
						Date dt = new Date();
						String dtt = dt.toString();
						fg.write(("\n" + dtt + "\n" + bluff[0] + "\nESCE\n").getBytes());
						alfa.esce(rr);
					} else
						System.out.println("Nessun sensore di nome <" + bluff[0] + ">   registrato.");
				}
				break;
			default :
				;
		}
		if (x != 5) {
			outDatagram = new DatagramPacket(outBuffer, outBuffer.length, sensAddr, sensPort);
			socket.send(outDatagram);
			/* SPEDIZIONE RISPOSTA */ }
	}
	/* while */
	socket.close();
	fg.close();
}
/*try*/

catch (UnknownHostException n) {
	System.out.println("\nSOS UnknownHostException nel Theread GESTSENSORI");
	System.exit(1);
} catch (SocketException v) {
	System.out.println("\nSOS SocketException nel Theread GESTSENSORI");
} catch (IOException e) {
	System.out.println("\nSOS IOException nel Theread GESTSENSORI");
}
}
/**
 * default = 0
 */
public int scelta(String msg) {
	int h = 0;
	if (msg.equals("PRESENTAZIONE"))
		h = 1;
	if (msg.equals("PRIMOVALORE"))
		h = 3;
	if (msg.equals("ALERT"))
		h = 4;
	if (msg.equals("ESCO"))
		h = 5;
	return h;
}
}
