package gest_bacino;

import java.net.*;
import java.io.*;
import java.lang.*;
public class CoordTime implements Runnable {
	int delay;
	DatagramSocket sock;
public CoordTime(int millisec) throws Exception {
	delay = millisec;
	(new Thread(this)).start();
}
public void run() {
	try {
		boolean ok;
		int tent;
		DatagramSocket sock = new DatagramSocket(121);
		byte outBuffer[];
		byte inBuffer[] = new byte[Manager.bufferLength];
		DatagramPacket outDtagram;
		DatagramPacket inDtagram = new DatagramPacket(inBuffer, inBuffer.length);
		InetAddress indirizzo_prim;
		while (!Manager.chiusura_sec) {
			tent = 1;
			boolean comandoio = false;
			Thread.sleep(delay);
			indirizzo_prim = InetAddress.getByName(Manager.altro_manager);
			/* mando al manager il msg AreYouAlive? */
			outBuffer = "A_U_ALIV".getBytes();
			outDtagram = new DatagramPacket(outBuffer, outBuffer.length, indirizzo_prim, 120);
			do {
				ok = true;
				sock.send(outDtagram);
				/* spedizione */
				System.out.println("\nSpedito " + tent + " msg <AreYouAlive?>");
				sock.setSoTimeout(Manager.wt);
				try {
					sock.receive(inDtagram);
					/* attesa risposta */ } catch (InterruptedIOException x) {
					System.out.println("Il primario non risponde!\nRiprovo .   .      .");
					ok = false;
					tent++;
					if (tent > 5) {
						comandoio = true;
						System.out.println("Divento un manager primario");
					}
				}
			}
			/* try */

			while (!ok && !comandoio);
			/* do */

			if (!comandoio) {
				String data = new String((inDtagram.getData())).trim();
				if (data.equals("Yes,Everything'sOk"))
					System.out.println("Ricevuto conferma <TUTTO OK>\n");
				else
					System.out.println("Il primario ha risposto con un msg oscuro: " + data);
			}
			/* if*/
			else {
				Manager.chiusura_sec = true;
				/*msg che mi invio per sbloccare una receive */
				outBuffer = "MI SA CHE\nSICHIUDETUTTO\nE FACCIO\nIL PRIMARIO\n".getBytes();
				outDtagram = new DatagramPacket(outBuffer, outBuffer.length, InetAddress.getLocalHost(), 110);
				sock.send(outDtagram);

				/* mando a tutti i sensori un msg CAMBIO_MAN. */
				for (int j = 0; j < Manager.max_tot_sens; j++) {
					if (Manager.nome_sens[j] != null) {
						outBuffer = "CAMBIO_MAN.".getBytes();
						outDtagram = new DatagramPacket(outBuffer, outBuffer.length, Manager.indirizIP[j], Manager.portasens[j]);
						sock.send(outDtagram);
					}
				}
				sock.close();

				/* lancio le quattro classi new  del manager primario*/
				new CoordinamPrim();
				new GestSensori();
				new GestoreTime(Manager.tempo_ril);
				new Input();
			}
			/* else */
		}
		/*while */
	}
	/*try*/




	catch (Exception x) {
		System.out.println("eccezione: esco");
		System.exit(1);
	}
}
/* run */
}
