package gest_bacino;

/**
 * Classe che si occupa di segnalare il tempo che passa...
 * 
 */

import java.net.*;
import java.io.*;
import java.lang.*;
import java.util.*;
public class GestoreTime implements Runnable {
	int delay;
public GestoreTime(int millisec) {
	delay = millisec;
	(new Thread(this)).start();
}
public void run() {
	Synchro beta = new Synchro();
	try {
		File ff = new File(Manager.filemonitoring);
		OutputStream fg = new FileOutputStream(ff);
		fg.write("INIZIO".getBytes());
		while (!Manager.chiusura_prim) {
			Thread.sleep(delay);
			System.out.println("\nTIMER: ci sono " + beta.conta() + " sensori collegati.");
			Date dt = new Date();
			String dtt = "\n" + dt.toString();
			fg.write(dtt.getBytes());
			
			/* contatto tutti i sensori collegati */
			for (int j = 0; j < Manager.max_tot_sens; j++) {
				if (Manager.nome_sens[j] != null) {
					fg.write(((new Rilevazione(j)).risposta()).getBytes());
				}
				/* if */
			}
			/* for */
		}
		/* while */
	} catch (InterruptedException x) {
		System.out.println("timer interrotto! ESCO.");
		/* delego il secondario */
		System.exit(1);
	} catch (SocketException c) {
		System.out.println("timer interrotto! ESCO.");
		/* delego il secondario */
		System.exit(1);
	} catch (IOException c) {
		System.out.println("timer interrotto! ESCO.");
		/* delego il secondario */
		System.exit(1);
	} catch (Exception c) {
		System.out.println("timer interrotto! ESCO.");
		/* delego il secondario */
		System.exit(1);
	}
}
}
