package gest_bacino;

import java.net.*;
import java.io.*;
import java.lang.*;
public class Presentazione {
	byte stato;
public Presentazione(int i) throws Exception {
	stato = (byte) 0;
	boolean ok = false;
	InetAddress manag_ADDR;
	Integer manag_PORT;
	/* VEDI SOTTO */

	DatagramSocket socket = new DatagramSocket();
	try {
		byte outBuffer[];
		byte inBuffer[];
		manag_ADDR = InetAddress.getByName(Sensore.ftrs[i]);
		manag_PORT = new Integer(Sensore.ftrs[i + 1]);
		System.out.println("Contatto il manager: " + Sensore.ftrs[i] + " sulla porta: " + Sensore.ftrs[i + 1]);
		DatagramPacket outDatagram;
		outBuffer = new byte[SensWait.bufferLength];
		outBuffer = (Sensore.ftrs[4] + "\nPRESENTAZIONE\n" + Sensore.ftrs[5] + "\n" + Sensore.ftrs[6]).getBytes();
		outDatagram = new DatagramPacket(outBuffer, outBuffer.length, manag_ADDR, manag_PORT.intValue());
		socket.send(outDatagram);
		/* SPEDIZIONE MSG DI INGRESSO */
		inBuffer = new byte[SensWait.bufferLength];
		DatagramPacket inDatagram = new DatagramPacket(inBuffer, inBuffer.length);
		socket.setSoTimeout(Sensore.wpt);
		socket.receive(inDatagram);
		/* A T T E S A di sapere SE il sensore  accettato e pu entrare */
		String data = new String(inDatagram.getData()).trim();
		System.out.println("Ottenuta risposta: " + data + "\n");
		if (data.equals("ESCI_SUBITO")) {
			System.out.println("ESCO");
			System.exit(1);
		}
		if (data.equals("OK")) {
			stato = (byte) 1;
			socket.close();
		} else
			if (data.equals("LASCIAMI STARE")) {
				stato = (byte) 2;
				socket.close();
			}
	} catch (InterruptedIOException e) {
		System.out.println("Il manager " + Sensore.ftrs[i] + " non risponde.\n");
		stato = 4;
		socket.close();
	}
}
/**
 * Insert the method's description here.
 * Creation date: (17/05/2001 12.00.35)
 * @return byte
 */
public byte statoManager() {
	return stato;
}
}
