package gest_bacino;

import java.net.*;
import java.io.*;
import java.lang.*;
public class PrimoContatto {
	boolean prim;
/** Si cerca di prendere contatto con un
potenziale manager primario gi operante, altrimenti,
se questi non esiste, ci si incarica di tale ruolo */
public PrimoContatto(String indIP) throws Exception {
	DatagramSocket sock = new DatagramSocket();
	byte outBuffer[] = new byte[256];
	byte inBuffer[] = new byte[256];
	try {
		/*  la porta di coord del secondario */
		InetAddress indirizzo;
		String localAddress = InetAddress.getLocalHost().getHostName().trim();
		indirizzo = InetAddress.getByName(indIP);
		DatagramPacket outDatagram;
		DatagramPacket inDatagram = new DatagramPacket(inBuffer, inBuffer.length);
		outBuffer = "MANAGER?".getBytes();
		outDatagram = new DatagramPacket(outBuffer, outBuffer.length, indirizzo, 120);
		sock.send(outDatagram);
		System.out.println("attesa che qualcuno risponda.  .    .");
		sock.setSoTimeout(Manager.wt);
		sock.receive(inDatagram);
		String data = new String(inDatagram.getData()).trim();
		if (data.equals("Eccomi: comando IO."))
			prim = false;
		else
			if (data.equals("Eccomi: comando IO. ESCI")) {
				System.out.println("RICEVUTO: \t<" + data + ">\nESCO.");
				sock.close();
				System.exit(1);
			} else {
				System.out.println("ERRORE: qualcuno mi ha risposto: <" + data + "> ?!");
				prim = true;
				sock.close();
			}
	}
	/* try */
	catch (InterruptedIOException e) {
		prim = true;
		sock.close();
	} finally {
		sock.close();
	}
}
public boolean primario() { return prim; }
}
