package gest_bacino;

import java.net.*;
import java.io.*;
import java.lang.*;
import java.util.*;
public class SensWait implements Runnable {	
	private Thread pres;
	static int bufferLength = 256;
	byte outBuffer[];
	byte inBuffer[] = new byte[bufferLength];
	Random ran = new Random();
public SensWait() throws Exception {
	
	pres = new Thread(this);
	pres.start();
}
public double misurazione() {
	double f = ran.nextDouble();
	return f;
}
/**
 * STAMPA
 */
public void prt(String scritta) {
	System.out.println(scritta);
}
public void run() {
	try {
		boolean ricevuto = false;
		int x;
		double misura;
		String measurement, data;
		InetAddress prAddr = InetAddress.getByName(Sensore.primAddr);
		InetAddress seAddr = InetAddress.getByName(Sensore.secAddr);
		DatagramSocket socket = new DatagramSocket();
		String localAddress = InetAddress.getLocalHost().getHostName().trim();
		DatagramPacket outDatagram;
		DatagramPacket inDatagram = new DatagramPacket(inBuffer, inBuffer.length);
		misura = misurazione();
		/*misurazione()  */
		measurement = (new Double(misura)).toString();
		outBuffer = (Sensore.ftrs[4] + "\nPRIMOVALORE\n" + measurement + "\n" + measurement + "\n").getBytes();
		outDatagram = new DatagramPacket(outBuffer, outBuffer.length, prAddr, Sensore.prPort);
		socket.send(outDatagram);
		/** SPEDIZIONE GRANDEZZA MISURATA */

		while (!Sensore.chiusura_sens) {
			socket.receive(inDatagram);
			/** ATTESA...*/
			data = new String((inDatagram.getData())).trim();
			prt("Manager said: " + data);
			switch (x = scelta(data)) {
	case 1 :
				{misura = misurazione();
				measurement = (new Double(misura)).toString();
				outBuffer = (Sensore.ftrs[4] + "\nVALORE\n" + measurement + "\n" + measurement + "\n").getBytes();
				outDatagram = new DatagramPacket(outBuffer, outBuffer.length, inDatagram.getAddress(), inDatagram.getPort());
				socket.send(outDatagram);
				/** SPEDIZIONE GRANDEZZA MISURATA */
		}
		break;
	case 2 :
		{
			prt("ESCO.");
			outBuffer = (Sensore.ftrs[4] + "\nESCO\nCIAO\nCIAO\n").getBytes();
			outDatagram = new DatagramPacket(outBuffer, outBuffer.length, prAddr, Sensore.prPort);
			socket.send(outDatagram);
			/** SPEDIZIONE GRANDEZZA MISURATA */
			Sensore.chiusura_sens = true;
		}
		break;
	case 3 :
		/* msg di entrata manager secondario */
		{
			if (Sensore.nonCeilSec) {
				prt("secondario entered");
				Sensore.nonCeilSec = false;
			} else
				prt("Incongruenze nei dati ricevuti.");
		}
		break;
	case 4 :
		;
		break;
	case 5 :
		/* cambio riferimento come manager primario */
		{
			if (!Sensore.nonCeilSec) {
				prt("Cambio primario");
				InetAddress temp;
				Sensore.nonCeilSec = true;
				/* inverto gli InetAddres */
				temp = prAddr;
				prAddr = seAddr;
				seAddr = prAddr;
			} else
				prt("Incongruenze nei dati ricevuti.");
		}
		break;
	default :
		prt("Ricevuti dati oscuri");
	}
}
/* while */
} catch (IOException e) {
	prt("IOException\nESCO da RUN");
	System.exit(1);
}
}
/**
 * default = 0
 */
public int scelta(String msg) {
	int h = 0;
	if (msg.equals("RILEVAZIONE"))
		h = 1;
	if (msg.equals("ESCI_SUBITO"))
		h = 2;
	if (msg.equals("ENTRATA_SEC"))
		h = 3;
	if (msg.equals("DATI_RICEV."))
		h = 4;
	if (msg.equals("CAMBIO_MAN."))
		h = 5;
	return h;
}
}
